// Generated by CoffeeScript 1.11.1
(function() {
  var Client, Gist, HttpError, Issue, Label, Me, Milestone, Notification, Org, Pr, Release, Repo, Search, Team, User, extend, request, url,
    extend1 = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    slice = [].slice;

  request = require('request');

  url = require('url');

  Me = require('./me');

  User = require('./user');

  Repo = require('./repo');

  Org = require('./org');

  Gist = require('./gist');

  Team = require('./team');

  Pr = require('./pr');

  Release = require('./release');

  Issue = require('./issue');

  Milestone = require('./milestone');

  Label = require('./label');

  Notification = require('./notification');

  extend = require('deep-extend');

  Search = require('./search');

  HttpError = (function(superClass) {
    extend1(HttpError, superClass);

    function HttpError(message, statusCode, headers, body1) {
      this.message = message;
      this.statusCode = statusCode;
      this.headers = headers;
      this.body = body1;
    }

    return HttpError;

  })(Error);

  Client = (function() {
    function Client(token1, options1) {
      this.token = token1;
      this.options = options1;
      this.limit = bind(this.limit, this);
      this.requestOptions = bind(this.requestOptions, this);
      this.request = this.options && this.options.request || request;
      this.requestDefaults = {
        headers: {
          'User-Agent': 'octonode/0.3 (https://github.com/pksunkara/octonode) terminal/0.0'
        }
      };
    }

    Client.prototype.me = function() {
      return new Me(this);
    };

    Client.prototype.user = function(name) {
      return new User(name, this);
    };

    Client.prototype.repo = function(name) {
      return new Repo(name, this);
    };

    Client.prototype.org = function(name) {
      return new Org(name, this);
    };

    Client.prototype.gist = function() {
      return new Gist(this);
    };

    Client.prototype.team = function(id) {
      return new Team(id, this);
    };

    Client.prototype.pr = function(repo, number) {
      return new Pr(repo, number, this);
    };

    Client.prototype.release = function(repo, number) {
      return new Release(repo, number, this);
    };

    Client.prototype.search = function() {
      return new Search(this);
    };

    Client.prototype.issue = function(repo, number) {
      return new Issue(repo, number, this);
    };

    Client.prototype.milestone = function(repo, number) {
      return new Milestone(repo, number, this);
    };

    Client.prototype.label = function(repo, name) {
      return new Label(repo, name, this);
    };

    Client.prototype.notification = function(id) {
      return new Notification(id, this);
    };

    Client.prototype.requestOptions = function(params1, params2) {
      return extend(this.requestDefaults, params1, params2);
    };

    Client.prototype.buildUrl = function(path, pageOrQuery, per_page, since) {
      var _url, q, query, separator, urlFromPath;
      if (path == null) {
        path = '/';
      }
      if (pageOrQuery == null) {
        pageOrQuery = null;
      }
      if (per_page == null) {
        per_page = null;
      }
      if (since == null) {
        since = null;
      }
      if ((pageOrQuery != null) && typeof pageOrQuery === 'object') {
        query = pageOrQuery;
      } else {
        query = {};
        if (pageOrQuery != null) {
          if ((since != null) && since === true) {
            query.since = pageOrQuery;
          } else {
            query.page = pageOrQuery;
          }
        }
        if (per_page != null) {
          query.per_page = per_page;
        }
      }
      if (this.token) {
        if (typeof this.token === 'string') {
          query.access_token = this.token;
        } else if (typeof this.token === 'object' && this.token.id) {
          query.client_id = this.token.id;
          query.client_secret = this.token.secret;
        }
      }
      if (query.q) {
        q = query.q;
        delete query.q;
        if (Object.keys(query).length) {
          separator = '&';
        } else {
          separator = '?';
        }
      }
      urlFromPath = url.parse(path);
      _url = url.format({
        protocol: urlFromPath.protocol || this.options && this.options.protocol || "https:",
        auth: urlFromPath.auth || (this.token && this.token.username && this.token.password ? this.token.username + ":" + this.token.password : ''),
        hostname: urlFromPath.hostname || this.options && this.options.hostname || "api.github.com",
        port: urlFromPath.port || this.options && this.options.port,
        pathname: urlFromPath.pathname,
        query: query
      });
      if (q) {
        _url += separator + "q=" + q;
        query.q = q;
      }
      return _url;
    };

    Client.prototype.errorHandle = function(res, body, callback) {
      var err, ref;
      if (Math.floor(res.statusCode / 100) === 5) {
        return callback(new HttpError('Error ' + res.statusCode, res.statusCode, res.headers));
      }
      if (typeof body === 'string') {
        try {
          body = JSON.parse(body || '{}');
        } catch (error) {
          err = error;
          return callback(err);
        }
      }
      if (body.message && ((ref = res.statusCode) === 400 || ref === 401 || ref === 403 || ref === 404 || ref === 410 || ref === 422)) {
        return callback(new HttpError(body.message, res.statusCode, res.headers, body));
      }
      return callback(null, res.statusCode, body, res.headers);
    };

    Client.prototype.get = function() {
      var callback, i, params, path;
      path = arguments[0], params = 3 <= arguments.length ? slice.call(arguments, 1, i = arguments.length - 1) : (i = 1, []), callback = arguments[i++];
      return this.request(this.requestOptions({
        uri: this.buildUrl.apply(this, [path].concat(slice.call(params))),
        method: 'GET'
      }), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.getNoFollow = function() {
      var callback, i, params, path;
      path = arguments[0], params = 3 <= arguments.length ? slice.call(arguments, 1, i = arguments.length - 1) : (i = 1, []), callback = arguments[i++];
      return this.request(this.requestOptions({
        uri: this.buildUrl.apply(this, [path].concat(slice.call(params))),
        method: 'GET',
        followRedirect: false
      }), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.getOptions = function() {
      var callback, i, options, params, path;
      path = arguments[0], options = arguments[1], params = 4 <= arguments.length ? slice.call(arguments, 2, i = arguments.length - 1) : (i = 2, []), callback = arguments[i++];
      return this.request(this.requestOptions({
        uri: this.buildUrl.apply(this, [path].concat(slice.call(params))),
        method: 'GET'
      }, options), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.post = function(path, content, options, callback) {
      var reqDefaultOption, reqOpt;
      if ((callback == null) && typeof options === 'function') {
        callback = options;
        options = {};
      }
      reqDefaultOption = {
        uri: this.buildUrl(path, options.query),
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        }
      };
      if (content) {
        reqDefaultOption.body = JSON.stringify(content);
      }
      reqOpt = this.requestOptions(extend(reqDefaultOption, options));
      return this.request(reqOpt, (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.patch = function(path, content, callback) {
      return this.request(this.requestOptions({
        uri: this.buildUrl(path),
        method: 'PATCH',
        body: JSON.stringify(content),
        headers: {
          'Content-Type': 'application/json'
        }
      }), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.put = function(path, content, options, callback) {
      if (!callback && options) {
        callback = options;
        options = {
          'Content-Type': 'application/json'
        };
      }
      return this.request(this.requestOptions({
        uri: this.buildUrl(path),
        method: 'PUT',
        body: JSON.stringify(content),
        headers: options
      }), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.del = function(path, content, callback) {
      return this.request(this.requestOptions({
        uri: this.buildUrl(path),
        method: 'DELETE',
        body: JSON.stringify(content),
        headers: {
          'Content-Type': 'application/json'
        }
      }), (function(_this) {
        return function(err, res, body) {
          if (err) {
            return callback(err);
          }
          return _this.errorHandle(res, body, callback);
        };
      })(this));
    };

    Client.prototype.limit = function(callback) {
      return this.get('/rate_limit', function(err, s, b) {
        if (err) {
          return callback(err);
        }
        if (s !== 200) {
          return callback(new HttpError('Client rate_limit error', s));
        } else {
          return callback(null, b.resources.core.remaining, b.resources.core.limit, b.resources.core.reset, b);
        }
      });
    };

    return Client;

  })();

  module.exports = function() {
    var credentials, token;
    token = arguments[0], credentials = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    return (function(func, args, ctor) {
      ctor.prototype = func.prototype;
      var child = new ctor, result = func.apply(child, args);
      return Object(result) === result ? result : child;
    })(Client, [token].concat(slice.call(credentials)), function(){});
  };

}).call(this);
